<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LinkedTransferExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.blocking</a> &gt; <span class="el_source">LinkedTransferExchange.java</span></div><h1>LinkedTransferExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.blocking;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;
import io.gitlab.littlesaints.protean.resources.Registrar;

import java.util.concurrent.LinkedTransferQueue;
import java.util.concurrent.TransferQueue;

/**
 * A {@link TransferQueue} based {@link MessageExchange} that uses a {@link LinkedTransferQueue}
 *
 * @param &lt;E&gt; the getType of elements
 */
public class LinkedTransferExchange&lt;E&gt; extends AbstractBlockingExchange&lt;TransferQueue&lt;E&gt;, E&gt; {

	public static final String TYPE = &quot;protean::exchange::java::linkedTransferQ&quot;;

<span class="fc" id="L39">	public static class _Registrar implements Registrar {</span>
		static {
<span class="fc" id="L41">			REGISTRY.register(TYPE, LinkedTransferExchange::new);</span>
<span class="fc" id="L42">		}</span>

		@Override
		public String toString() {
<span class="fc" id="L46">			return &quot;LinkedTransferExchange::Registrar&quot;;</span>
		}
	}

    private final Writer&lt;E&gt; writer;

	public LinkedTransferExchange(final int capacity, final boolean isMultiProducer, final Config config) {
<span class="fc" id="L53">		super(new LinkedTransferQueue&lt;&gt;());</span>
<span class="fc" id="L54">		this.writer = new LinkedTransferWriter();</span>
<span class="fc" id="L55">	}</span>

	@Override
	public Writer&lt;E&gt; newWriter() {
<span class="fc" id="L59">		return writer;</span>
	}

<span class="fc" id="L62">	private class LinkedTransferWriter implements Writer&lt;E&gt; {</span>
		@Override
		public boolean put(E e) {
			while (true) {
				try {
<span class="fc" id="L67">					queue.put(e);</span>
<span class="fc" id="L68">					break;</span>
<span class="nc" id="L69">				} catch (InterruptedException x) {</span>
<span class="nc" id="L70">					x.printStackTrace();</span>
<span class="nc" id="L71">				}</span>
			}
<span class="fc" id="L73">			return true;</span>
		}
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>